// Bambino
// TAB FILE > varsCons41.h

/*== NEW ====================================================
boolean f_Bequiet     // 1-> Debug messages off
boolean f_MsgForMe    // 0-> messages are for other robots 
boolean f_hashcmnd =0 ;   // processing a hash command
boolean f_hashhashSTOP ;  // ##Stop from external commander
char rname ;     // robot name  - default 'A' set in init41.h
char rgroup ;    // robot group - default '0' set in init41.h  
char hashgroup ;     // current group for #cmnds
*/

//EEPROM addresses
const byte Ef_walking =255;
const byte ErollC     =254;
const byte EpaceC     =253;
const byte Erollby    =252;
const byte Epaceby    =251;
const byte Erollmin   =250;
const byte Erollmax   =249;
const byte Epacemin   =248;
const byte Epacemax   =247;
const byte Ergroup    =246;
const byte Ername     =245;
//== VARIABLES and CONSTANTS ================================     
//MIND                       
boolean debug ;           //debug =0 - turn off debug messages, debug =1 - turn them on
boolean f_walking ;       // 1=> walking enabled , 0=> walking disabled
boolean f_BeQuiet ;       // 1-> Debug messages off
boolean f_MsgForMe ;      // 0-> messages are for other robots 
boolean f_hashcmnd =0 ;   // processing a hash command
boolean f_hashhashSTOP ;  // ##Stop from external commander
boolean f_TurnedRight ;   // 1=> last turn was Right, 0=> last turn was Left 
boolean f_forwards =1;    // current direction, 1=>forwards, 0=>backwards, controls step direction in turns
boolean f_turning =0;     // controls pace in paceRightForward()) and paceRightBackwards() when turning,   f_turning =1 =>turning
boolean f_AtLight ;       // true if facing Light
boolean f_AtDark ;        // true if facing Dark
boolean f_holeRight ;     // 0=> no hole, 1=> hole eg a table edge,  
boolean f_holeLeft ;      // 0=> no hole, 1=> hole eg a table edge
boolean f_obstacleRight ; // 0=> no obstacle, 1=> obstacle 
boolean f_obstacleLeft ;  // 0=> no obstacle, 1=> obstacle
byte cmnd =0 ;            // current command     
char rname ;         // robot name
char rgroup ;        // robot group 
char hashgroup ;     // current group 
//SERVOS
//Servo values are in units of 1 degree, 0 - 180, centre at 90"
byte rollC =90;      // roll centre = 90 degrees (ie 1500us) => upright
byte paceC =90;      // pace centre = 90 degrees (ie 1500us) => feet together
byte Servoframe =20; // Servo frame rate millisecs
byte rollat ;        // Roll servo position, +ve roll to right 
byte paceat ;        // Pace servo position, +ve left foot forwards
byte rollby ;        // roll angles about rollC
byte paceby ;        // pace angles about paceC
byte turnby;         // servo turn angles about paceC
byte rollspeed ;     // roll servo speed  
byte pacespeed ;     // pace servo speed
byte rollspeedmax ;  // max speed for speedup()
byte pacespeedmax ;  // max speed for speedup()
byte rollto ;        // roll servo value to move to
byte paceto ;        // pace servo value to move to
//== SENSORS ================================================
//Eyes
int ReyeLight ;      // light level read from R whisker light sensors, integer values between 0 and 1023
int LeyeLight ;      // light level read from L whisker light sensors, integer values between 0 and 1023
const byte LeftRightLightTurnThreshold  =10 ;  // difference% between LeyeLight and ReyeLight for a Light turn
//===========================================================
//Whiskers
int RwhiskerLight;   // reading from Right whisker sensor, LED on,  integer values between 0 and 1023
int LwhiskerLight ;  // reading from Left whisker sensor,  LED on,  integer values between 0 and 1023
int RwhiskerDark ;   // reading from Right whisker sensor, LED off, integer values between 0 and 1023
int LwhiskerDark ;   // reading from Left whisker sensor,  LED off, integer values between 0 and 1023
int RwhiskerDifference ; // difference between RwhiskerLight and RwhiskerDark
int LwhiskerDifference ; // difference between LwhiskerLight and LwhiskerDark
const byte obstacleThresholdRight =20 ;  // difference between RwhiskerLight and RwhiskerDark for an obstacle
const byte obstacleThresholdLeft  =20 ;  // difference between LwhiskerLight and LwhiskerDark for an obstacle
//===========================================================
//Beard
int RbeardLight ;    // reading from Right beard sensor, LED on,  integer values between 0 and 1023
int LbeardLight ;    // reading from Left beard sensor,  LED on,  integer values between 0 and 1023
int RbeardDark ;     // reading from Right beard sensor, LED off, integer values between 0 and 1023
int LbeardDark ;     // reading from Left beard sensor,  LED off, integer values between 0 and 1023
int RbeardDifference ; // difference between RbeardLight and RbeardDark
int LbeardDifference ; // difference between LbeardLight and LbeardDark
const byte holeThresholdRight =10 ;      // difference between RbeardLight and RbeardDark for a hole
const byte holeThresholdLeft  =10 ;      // difference between LbeardLight and LbeardDark for a hole 
//===========================================================
// Ultrasonic module HC-SR04
  // According to Parallax's datasheet for the PING))), 
  // See: http://www.parallax.com/dl/docs/prod/acc/28015-PING-v1.3.pdf
  // sound travels at 1130 feet per second, i.e. 73.746 microseconds per inch
  // (or the speed of sound is 340 m/s or 29 microseconds per centimeter).
  // This gives the distance travelled by the ping, outbound and return,
  // so we divide by 2 to get the distance of the obstacle
  // and then divide by 29 to get cm or divide by 73.746 to get inches,
  // i.e. divide by 2*29=58 to get cm, 
  // or divide by 2*73.746=147.492 =>147 to get inches.
  // Note the output of the HC_SR04 never goes LOW unless an echo is received.
  // The default time-out for pulseIn() is 1 second (Arduino language reference).
  // so if there is no obstacle to return an echo then unless a timeout is set
  // pulseIn() will return 0 after its timer times out and this routine 
  // will hang for 1 second.
  // The HC-SR04 has a range of about 10 feet, then since the speed of sound
  // is about 1 foot per milli-second it will take 20ms at maximum range.
  // so UStimeout is set to 20000 =20ms
const int UStimeout =20000;     //20ms
const byte uscm     =58;
const byte usinch   =147;
boolean f_cm        =true;      // US distance in cm
byte objectRange ;    // distance to object detected by HC-SR04 sensor 
//===========================================================
