//BA42_Autorun.ino

char thisrobot[] ="Bambino ";
char thisprog[]  ="BA42_Autorun";
/*
Sketch uses 16406 bytes (50%) of program storage space. Maximum is 32256 bytes.
Global variables use 658 bytes (32%) of dynamic memory, leaving 1390 bytes for local variables. Maximum is 2048 bytes.
*/
//== #define ================================================
//#define BambinoPM
//#define BambinoMM
#define BambinoM2

/*
== Notes ====================================================
Introducing
  ba<0-8> = set Act to Autorun on PowerOn or Reset, 0 means no autorun
  ba9 = set Autorun act to run when there is nothing else to do
Bugfix
  If S was used to disable walking by turning off the servos and further walking commands given 
  then the actual feet positions no longer agreed with rollat and paceat so when the servos were re-enabled a jerk often occurred.
  The new variables Srollat and Spaceat are used to remember rollat and paceat when S is used to turn off walking
  and rollat and paceat are set to Srollat and Spaceat when walking is re-enabled.  
=============================================================
Note - The Arduino Serial Monitor can't send [Esc]. 
       If another Terminal is used which can send [Esc] then at GetCcmnd() this will be printed,
	     which may print as a symbol or the Terminal may change it to "."
     
Bugs -	   

improvements? - 
- GetAct should use GetCcmnd to read Act from current act rather than a prompt. rx,lx,cx would then be playable
- void GetCcmnd()	  could use   case 0:   - why?

To do next - 
?r print Reactions
/R ! change to Reactions page1 0 changes to Rpage0   8x16 byte slots in each Rpage 
                             Active page set in active BeHaves   
/A change to Acts Apage1     0 changes to Apage0   8x32 byte slots in each Apage
/B change to BeHaviour page  8x16 byte slots, load only, /B1 - /B8

Ername, Ergroup, Default BeHaviour - need to be  separate
   
print 23 to 31 for 'm' machine
31 Ef_walking =255;
30 ErollC     =254;  90 rollC   set in initPM34.h from EEPROM set in initialiseEEPROM()
29 EpaceC     =253;  90 paceC   set in initPM34.h from EEPROM set in initialiseEEPROM()
28 Erollby    =252;  15 rollby  set in initPM34.h from EEPROM set in initialiseEEPROM()  physical max 20
27 Epaceby    =251;  15 paceby  set in initPM34.h from EEPROM set in initialiseEEPROM()  physical max 20 
26 [Erollmin   =250;]
25 [Erollmax   =249;]
24 [Epacemin   =248;]
23 [Epacemax   =247;]
22 Ergroup     =246;
21 Ername      =245;
20 244
19 243
18 242
[ boolean f_cm ]
print 0 to here plus 31 for Mind
17 Sonar awareAt - 5cm units - 1 to 9 = 5cm to 45cm
16 Sonar TooNear - 5cm units - 1 to 9 = 5cm to 45cm
15 LeftRightLightTurnThresholdScale - 1-9 in units of 1%
14 LeftRightLightTurnThreshold - 0-9 in units of Scale
13 holeThresholdScale - 1-9 in units of 1%
12 holeThresholdRight =10; % - 0-9  units of 5%  // difference between RbeardLight and RbeardDark for a hole
11 holeThresholdLeft  =10; % - 0-9  units of Scale // difference between LbeardLight and LbeardDark for a hole 
10 obstacleThresholdScale  - 0-9  units of 1%  
 9 obstacleThresholdRight =20; % - 0-9  units of 5%  // difference between RwhiskerLight and RwhiskerDark for an obstacle
 8 obstacleThresholdLeft  =20; % - 0-9  units of 5%  
 7 rollspeedmax 1-9    =4;  // quite fast 
 6 pacespeedmax 1-9    =6;  // quite fast 
 5 rollspeed    1-9    =1 slow
 4 pacespeed    1-9    =1 slow
 3 turnby      0-9 units of 20us  set in initPM34.h from EEPROM set in initialiseEEPROM()  paceby 
 2 rollby
 1 paceby
 0 autoAct      0-8
  
bp(1-8) - print Behaviour in EEPROM (1-8)
     all moveby values are 2* command values, only print command values
   - f_walking, rollC, paceC, rollby, paceby, rollmin, rollmax, pacemin, pacemax
lb(1-8) - load b(1-8)  Load Mind  - EEPROM values    - byte values - prefix with #
b(1-8) - load Mind (RAM values) with behaviour from EEPROM (1-8)
b8 - default behaviour loaded to Mind (RAM) in Init
Cr+,Cr-(1-9) - alter rollC in RAM and EEPROM in current mind
Cp+,Cp-(1-9) - alter paceC in RAM and EEPROM in current mind 
u+(1-8) - ultrasonic furthest range aware at, further ignored
u-(1-8) - ultrasonic closest range, less is too close

b0 - reinitialise behaves - do a software restart using the watchdog
b<1-8> - select current behaviour
16 bytes for behaves => 8 in 128 bytes
sr,sp,srm,spm,mr,mp,mt,u-,u+,(spare 7)
two bytes each => 16 bytes, => 8 in 128 bytes
bG-<{0},1-8> - Act to be done on hole-tests left & right true 
bGR<{0},1-8> - Act to be done on hole-test right true 
bGL<{0},1-8> - Act to be done on hole-test left  true 
bW-<{0},1-8> - Act to be done on Whisker-tests left & right true 
bWR<{0},1-8> - Act to be done on Whisker-test right true 
bWL<{0},1-8> - Act to be done on Whisker-test left  true
bU+<{0},1-8> - Act to be done on Ultrasonic distance <= aware at
bU-<{0},1-8> - Act to be done on Ultrasonic distance <= too near
=============================================================
Primary commands used
012345678 ?#. ABEFGHLRSUVWX bclrstvw
   
COMMANDS
======== 
'.',[Esc] - quit current operation - recording, playing, input
'S' - Stop/Start
'0' - use page0 for the next Act
'1'-'8' the routine or Act to record or replay
'F' - Forwards one step
'B' - Backwards one step
'R' - turn Right one step
'L' - turn Left one step
'H' - Halt with both feet together
'V' - Voice, make a beep, whee
'U' - read Ultrasonic sensor and react to objectRange using avoidUObjects() behaviour rules
'W' - read Whisker sensors and avoid holes (if any) using avoidObstacles() behaviour rules
'G' - read Beard sensors and avoid obstacles (if any) using avoidHoles() behaviour rules
'A' - beAlive()  until '.' or Esc or reset      // the loop() from B_PM22_BeAlive
'X' - Xplore()   until '.' or Esc or reset      // Wander()
'E' - Experiment - user routine  until '.' or Esc or reset
'v', 'b','e','o' choose sound: 'b' bip, 'e' whee, 'o' whoa
'w', '1'-'9' - wait 1 - 9 seconds 
'su' - speedup, speed is increased by 1 up to max
'sd' - speed down, speed is divided by 2 down to 1
's','1'-'9' set speed, both roll and pace speeds set to the same
'sr','1'-'9' set roll speed                              units of servo degrees change per frame
'sp','1'-'9' set pace speed                              units of servo degrees change per frame
'sm' - set rollspeedmax to current rollspeed, set pacespeedmax to current pacespeed
'srm' - set rollspeedmax to current rollspeed
'spm' - set pacespeedmax to current pacespeed
'b','#','A-Z','a-z' - robot name  A-Z,a-z
        '1'-'9' - robot group 1 - 9
    'a','0'-'8' - set Autorun act '1' - '8', '0' no Autorun act   
    'a','9'     - set Autorun act to run when there is nothing else to do    
    'p','1'-'9' - set paceby - step length                units of 2 servo degrees
    't','1'-'9' - set turnby - step length in turns       units of 2 servo degrees
    'r','1'-'9' - set rollby - roll amount when stepping  units of 2 servo degrees
    'q' - Quiet - turn off Debug messages
    '@' - Adjust Servos 
't','a' - turn Away from leading foot, will be used in avoid Acts
    'm' - turn Memory (same way as last turn, will be used in avoid Acts
    'o' - turn Other way from last time, will be used in avoid Acts 
    'l' - turn to light
    'd' - turn to dark
    '@l' - turn until @ light
    '@d' - turn until @ dark    
'r','1'-'8' - Record moves into selected Act in EEPROM
'c','1'-'8','1'-'8' -  copy one Act to another Act, xy,x0y,0xy,0x0y
'l','1'-'8' - load Act, like 'r' but records commands into EEPROM without playing them
'?','h' - print Help instructions
    '1'-'8' - Print moves in selected Act '1' - '8'
    'p' - print current Page
    '?' - print current Page
    'd' - Dump out all acts to the PC, same as 'p' but without the Act and moves numbers.
    'b' - print Behaviour - behaviour variables in RAM
    'm' - print Mind - all Acts, Behaviour
'#','*' - message for all robots, robots silent
    '0-9' - message for robot group 0 - 9, robots silent
    'A-z' - message for robot name A-z in current group, other robots silent
    '#' - (default) robots stop, obey all commands and send messages     
          useful to talk to an unknown robot or put all in the stopped state 
    '<' - do Default Act   
    '>' - resume Act   
    '?' - all robots reply with their name and group - delayed according to name
   
The whiskerLEDs glowing dim indicate Bambino is ready for a command.
If other keys are pressed, including lower case keys, then the Whisker LEDs will flash badkey().
(MM - mouth glows dim while ready and Beard LEDs used for badkey().) 
=============================================================
BEHAVES
=======
power-on defaults
----------------
speed behaves  - set in void setup()  
  rollspeed     is 1             
  pacespeed     is 1
  rollspeedmax  is 4
  pacespeedmax  is 6
move behaves   - set in void setup()  init42.h 
  rollby   is EEPROM value,    set by B_PM04_Servos or AdjustServos()
  paceby   is EEPROM value,    set by B_PM04_Servos or AdjustServos()
  turnby   is paceby

//== SECTIONS ===============================================
//== NEW 
//== CHANGED
//== INCLUDES
//     pins20.h     - pin usage
//     varsCons42.h - EEPROM addresses, general, Ultrasonic module HC-SR04
//     EEPROM.h       - the Arduino EEPROM library
//     avr/pgmspace.h - to allow the printHelp() text to be in ProgramSpace
//== VARIABLES and CONSTANTS 
//== HELP TEXT 
//     PROGMEM
//== SETUP
//     init42.h     - Initialise various things
//== LOOP
//== FUNCTIONS
//   GetCcmnd()	       //reads Serial or playing Act until Ccmnd != 0, prints Ccmnd
//   RecordCcmnd()	
//   makeCcmndDigit()  ensure 1-9
//   waitCcmndSecs()   //read delay time from Act and wait
//   DumpActs()        //Dump Acts, Print without names and length
//   loadAct()
//   copyAct()
//   Ccmnd <- PlayAct() 
//   printMind()
//   PrintAllActs()
//   printAct()
//   Act <- getAct()  //called when recording, loading, printing and copying Acts 
//   setEEPROMindexes(char Act)      //  changes EEPROMindex, ActEnd
//   printHelp()
//   badkey()         // indicate invalid key
//   USreact()        // read Ultrasonic sensor and react to objectRange using avoidUObjects() behaviour rules
//   WhiskerReact()   // read Whisker sensors and avoid holes (if any) using avoidObstacles() behaviour rules
//   BeardReact()     // read Beard sensors and avoid obstacles (if any) using avoidHoles() behaviour rules
//   beAlive()        // the loop() from BA22_BeAlive
//   redLEDdim() - BambinoMM only
//   redLEDon()
//   redLEDoff() 
//   bip()            // make a bip sound
//   whiskerLEDsDim() - not BambinoMM
//   whiskerLEDsOff() - not BambinoMM
//TAB FILES
//   AdjustServos39.ino
//     AdjustServos(), printEEPROMvalues(), printAdjustInstructions() 
//     PROGMEM adjust_instructions
//   acts40.ino
//     ACTS - WanderSteps(steps), Wander()
//            RightStep(steps), LeftStep(steps)
//            rock(repeats), shuffle(repeats)
//     SOUND -  whee(), whoa(), beep(byte beeppin,int beepfreqHz,long beeptime)  
//   behaviour20.ino
//     BEHAVIOUR MODIFIERS - speeddown(), speedup()
//     BEHAVIOUR RULES - avoidUObjects(), avoidObstacles(), avoidHoles()
//   sense41.ino
//     SENSE - dist_HC_SR04()
//           - readWhiskers(), QueryObstacle(), showWhiskerLightLevels() 
//           - readBeard(), QueryEdge(), showBeardLightLevels() 
//           - readLight()
//   movement34.ino
//     MOVEMENT - forward(), backward(), turnRight(), turnLeft(), 
//                halt(), 
//                rollCentre(), rollLeft(), rollRight(),
//                paceCentre(), paceLeftForward(),  paceRightForward(), 
//                              paceLeftBackward(), paceRightBackward(), 
//                              turnLeftForward(),  turnRightForward(), 
//                              turnLeftBackward(), turnRightBackward(), 
//                rollmove(), pacemove()
//   skills41.ino
//     SKILLS - turnLight(), turnDark(), turnAtLight(), turnAtDark()
//     META MOVEMENT - turnAway(), turnMemory(), turnOther()  
//   servos40.ino
//     SERVOS - ServosInitC()
//              ServoPulse(byte Spin, int Spulse)
//   system42.ino
//     SYSTEM - disable_walking(), enable_walking(), toggle_f_walking(), initialiseEEPROM()
//===========================================================
*/

/*== NEW ====================================================
boolean f_runDefault =false;  //run Default when nothing else to do
varsCons42.h
  const byte EautoAct   =244;
  byte Srollat ;       // remember rollat when walking disabled
  byte Spaceat ;       // remember paceat when walking disabled
init42.h
 if ('0'>EEPROM.read(EautoAct) || '8'<EEPROM.read(EautoAct) ) 
    {EEPROM.write(EautoAct,'0');} // in case it is not initialised
  Srollat =rollat;
  Spaceat =paceat;               
*/
/*== CHANGED ================================================
deleted - #define autoAct '8'   //Act '1' - '8' to autorun
varsCons41.h -> varsCons42.h          const byte EautoAct   =244;
init41.h -> init42.h  -   if ('0'>EEPROM.read(EautoAct) || '8'<EEPROM.read(EautoAct) ) 
                            {EEPROM.write(EautoAct,'0');} // in case it is not initialised
system41.ino -> system42.ino   disable_walking(), enable_walking(), toggle_f_walking()
void loop()
  if (f_doDefault)   // true on the first loop and #< only
    { f_doDefault =false;                // don't do it again
      Ccmnd =EEPROM.read(EautoAct);
      if(Ccmnd=='0') { Ccmnd ='.'; }     // '0' -> no autorun so do stop 
    }   
  case '.':   if (f_runDefault) { f_doDefault =true; }
  case 'b':   case 'a':     if(Ccmnd<'0' || Ccmnd>'9') { Ccmnd ='0'; break; }
                            if (Ccmnd=='9') {f_runDefault =true; break;}    
  case '#':   case '#':   f_runDefault =false;  
void printBehaviour()
  Serial.print(char(EEPROM.read(EautoAct))); Serial.println(" autoAct");             
//== HELP TEXT
const char h_brun[] PROGMEM = "    'a','0'-'8' set Autorun act, '0' = no autorun";  
*/
//== INCLUDES ===============================================
#include "pins20.h"
#include "varsCons42.h"
#include <EEPROM.h>           // to read and write internal EEPROM
  // EEPROM.write(address,bytevalue)
  // bytevalue =EEPROM.read(address)
#include <avr/pgmspace.h>     // for PROGMEM for the printHelp() text
  
//== VARIABLES and CONSTANTS ================================
boolean f_recording =false;   //recording an Act
boolean f_recordC =false;     //record current Command
boolean f_play =false;        //Play current Act
boolean f_doDefault =true;    //true for the first loop and #< only
boolean f_runDefault =false;  //run Default when nothing else to do
const byte NL =10;            //NewLine value
const byte LF =10;            //LineFeed value                                  
const byte CR =13;            //Carriage Return value
const byte Esc =27;           //Esc key value
char Act;                     //current Act as '1' - '8'
byte actIndex =0;             //current Act number, set to default           
int EEPROMindex =-1;          //index to moves in an Act in EEPROM, -1 => nothing to continue with #>
int hashhashAt;               //copy of EEPROMindex at hashhashSTOP 
int ActEnd;                   //end address of current recording Act in EEPROM
int moves =0;                 //current move
char Ccmnd =0;                //current Character command, default null command
byte epage =1;                //the Act page for the current Act, default page =1 for  Acts 1-8 and page =2 for 01-08

//== HELP TEXT ==============================================
// see http://arduino.cc/en/Reference/PROGMEM

char helpbuffer[80];          //buffer for helptext in PROGMEM
  
const char h_0[]    PROGMEM = "'0' - use page0 for the next Act"; 
const char h_1[]    PROGMEM = "'1'-'8' the routine or Act to record or replay";
const char h_Q[]    PROGMEM = "'.',[Esc] - quit playing or recording";
const char h_F[]    PROGMEM = "'F' - Forwards one step";
const char h_B[]    PROGMEM = "'B' - Backwards one step";
const char h_R[]    PROGMEM = "'R' - turn Right one step";
const char h_L[]    PROGMEM = "'L' - turn Left one step";
const char h_H[]    PROGMEM = "'H' - Halt with both feet together";
const char h_V[]    PROGMEM = "'V' - Voice, make a beep";
const char h_S[]    PROGMEM = "'S' - Stop/Start - disable/enable servos";
const char h_U[]    PROGMEM = "'U' - read Ultrasonic sensor and react";
const char h_W[]    PROGMEM = "'W' - read Whisker sensors and avoid obstacles";
const char h_G[]    PROGMEM = "'G' - read Beard sensors and avoid holes";
const char h_A[]    PROGMEM = "'A' - beAlive()   until quit";
const char h_X[]    PROGMEM = "'X' - Xplore()   until 'Q' or reset";
const char h_E[]    PROGMEM = "'E' - Experiment - user routine  until 'Q' or reset";
const char h_v[]    PROGMEM = "'v','b','e','o' - choose sound: 'b' bip, 'e' whee, 'o' whoa";
const char h_w[]    PROGMEM = "'w', '1'-'9' - wait 1 - 9 seconds"; 
const char h_su[]   PROGMEM = "'su' - speedup, speed is increased by 1 up to max"; 
const char h_sd[]   PROGMEM = "'sd' - speed down, speed is divided by 2 down to 1"; 
const char h_s[]    PROGMEM = "'s', '1'-'9' set roll and pace speeds to the same"; 
const char h_sr[]   PROGMEM = "'sr', '1'-'9' set roll speed"; 
const char h_sp[]   PROGMEM = "'sp', '1'-'9' set pace speed"; 
const char h_sm[]   PROGMEM = "'sm' - set rollspeedmax, pacespeedmax to current speeds";
const char h_srm[]  PROGMEM = "'srm' - set rollspeedmax to current rollspeed"; 
const char h_spm[]  PROGMEM = "'spm' - set pacespeedmax to current pacespeed"; 
const char h_bn[]   PROGMEM = "'b','#','A'-'z' - robot name  A-z";
const char h_bg[]   PROGMEM = "        '0'-'9' - robot group 0 - 9";
const char h_brun[] PROGMEM = "    'a','0'-'8' set Autorun act, '0' = no autorun";  
const char h_bdo[]  PROGMEM = "    'a','9'     set Autorun act to run when there is nothing else to do";    
const char h_bp[]   PROGMEM = "    'p','1'-'9'  paceby =2*cmnd - step length";
const char h_bt[]   PROGMEM = "    't','1'-'9'  turnby =2*cmnd - step length in turns";
const char h_br[]   PROGMEM = "    'r','1'-'9'  rollby =2*cmnd - roll amount when stepping";
const char h_bq[]   PROGMEM = "    'q' - Quiet - turn off Debug messages";
const char h_badj[] PROGMEM = "    '@' - Adjust Servos"; 
const char h_ta[]   PROGMEM = "'t','a' - turn Away from leading foot"; 
const char h_tm[]   PROGMEM = "    'm' - turn Memory (same way as last turn";
const char h_to[]   PROGMEM = "    'o' - turn Other way from last time";
const char h_tl[]   PROGMEM = "    'l' - turn towards Light";
const char h_td[]   PROGMEM = "    'd' - turn towards Dark";
const char h_tAtl[] PROGMEM = "    '@l' - turn until facing Light";
const char h_tAtd[] PROGMEM = "    '@d' - turn until facing Dark";
const char h_r[]    PROGMEM = "'r','1'-'8' - Record moves into EEPROM";
const char h_c[]    PROGMEM = "'c','1'-'8','1'-'8' -  copy one Act to another Act,  xy,x0y,0xy,0x0y";
const char h_l[]    PROGMEM = "'l','1'-'8' - load Act into EEPROM without playing it"; 
const char h_qh[]   PROGMEM = "'?','h' - print Help - these instructions";
const char h_qx[]   PROGMEM = "    '1'-'8' - print moves in selected Act '1' - '8'";
const char h_qa[]   PROGMEM = "    'a' - print all Acts";
const char h_qq[]   PROGMEM = "    '?' - print all Acts";
const char h_qd[]   PROGMEM = "    'd' - Dump out all acts to the PC"; 
const char h_qb[]   PROGMEM = "    'b' - print Behaviour - behaviour variables in RAM";
const char h_qm[]   PROGMEM = "    'm' - print all Acts, Behaviour";
const char h_mr[]   PROGMEM = "'#','*' - message for all robots, robots silent";
const char h_mn[]   PROGMEM = "    '0-9' - message for robot group 0-9, robots silent";
const char h_mg[]   PROGMEM = "    'A-z' - message for robot name A-z in current group, other robots silent";
const char h_ms[]   PROGMEM = "    '#' - (default) stop, obey commands and send messages";    
const char h_ms2[]  PROGMEM = "          useful to talk to an unknown robot or put all in the stopped state"; 
const char h_mAd[]  PROGMEM = "    '<' - do default Act";    
const char h_mAr[]  PROGMEM = "    '>' - resume Act";    
const char h_mq[]   PROGMEM = "    '?' - print all names and groups - delayed depending on name ";    
  
PROGMEM const char * const help_table[] =
  { h_0,    h_1,    h_Q,    h_F,    h_B,    h_R,    h_L,    h_H,
    h_V,    h_S,    h_U,    h_W,    h_G,    h_A,    h_X,    h_E,
    h_v,    h_w,    h_su,   h_sd,   h_s,    h_sr,   h_sp,   h_sm,   h_srm,  h_spm,
    h_bn,   h_bg,   h_brun, h_bdo,  h_bp,   h_bt,   h_br,   h_bq,   h_badj,
    h_ta,   h_tm,   h_to,   h_tl,   h_td,   h_tAtl, h_tAtd,
    h_r,    h_c,    h_l,
    h_qh,   h_qx,   h_qa,   h_qq,   h_qd,   h_qb,   h_qm,    
    h_mr,   h_mn,   h_mg,   h_ms,   h_ms2,  h_mAd,  h_mAr,  h_mq    
  };

//== SETUP ==================================================
void setup() 
{ 
  #include "init42.h" //Initialise various things
  
  //now configure Bambino
  f_forwards =1;    // set default
  rollspeed =1;     // start off slow
  pacespeed =1;     // start off slow
  rollspeedmax =4;  // quite fast 
  pacespeedmax =6;  // quite fast  
}
//== LOOP ===================================================
void loop()
{ f_recordC =true;     // record Command, default =true
  
#ifdef BambinoMM 
  redLEDdim();         //indicate ready for command except    
  if(f_recording)  { redLEDon(); }
  if(f_play)       { redLEDoff(); }
#else
  if(f_recording)  { redLEDon(); } else { redLEDoff(); }
  if(f_play)       { whiskerLEDsOff();  }
                   else
                   {  whiskerLEDsDim(); }    //indicate ready for command
#endif      

  if(!f_play)      { if(!f_BeQuiet){Serial.print(">"); }}    //ready prompt
  if (f_doDefault)   // true on the first loop and #< only
    { f_doDefault =false;                // don't do it again
      Ccmnd =EEPROM.read(EautoAct);
      if(Ccmnd=='0') { f_runDefault =false;  Ccmnd ='.'; }     // '0' -> no autorun, can't run it so do stop 
    }   
   else
    // if f_hashhashSTOP skip GetCcmnd() and process Ccmnd '.' from ##
    { if(!f_hashhashSTOP) { GetCcmnd(); } }   //reads Serial or playing Act until Ccmnd != 0, prints Ccmnd

DoCommand:
  switch (Ccmnd) 
  { case LF:    f_recordC =false;  break;     //linefeed
    case CR:    f_recordC =false;  break;     //carriage return
    case ' ':   break;     //strip space
    case ',':   break;     //strip comma
    case Esc:   Ccmnd ='.';     //[Esc] key, fall through to '.'
    case '.':   if (f_recording) {  EEPROM.write(EEPROMindex,'.'); }     //terminated string
                f_recording =false;
                f_play =false;
                if (!f_hashhashSTOP) { EEPROMindex =-1; };       // so there is nothing to continue with #>
                f_hashhashSTOP =false;
                if(!f_BeQuiet){Serial.println();}
                if (f_runDefault) { f_doDefault =true; }
                break;
    case 'A':	  // if recording record 'A' otherwise do beAlive() until 'Q' or reset
                if (!f_recording) { beAlive(); }  break;
    case 'X':	  // if recording record 'X' otherwise do Xplore() until 'Q' or reset
                if (!f_recording) { Xplore(); }  break; 
    case 'E':	  // if recording record 'E' otherwise do Experiment() until 'Q' or reset
                if (!f_recording) { Experiment(); }  break; 
    case '0':   epage =2;  break;  //reset to 1 at the end of setEEPROMindexes(char Act)
    case '1':   // fall through
    case '2':   // fall through
    case '3':   // fall through
    case '4':   // fall through
    case '5':   // fall through
    case '6':   // fall through
    case '7':   // fall through
    case '8':   if (!f_recording) { f_play =true; Act =Ccmnd;  setEEPROMindexes(Act); }  break;
    case 'F':   forward();      break;        
    case 'B':   backward();     break;        
    case 'R':   turnRight();    break;        
    case 'L':   turnLeft();     break;        
    case 'H':   halt();         break; 
    case 'V':   whee();         break;   //Spkr and LED on different pins           
    case 'S':   f_recordC =false;
                toggle_f_walking(); 
                if(!f_BeQuiet)
                  {if (f_walking) {Serial.println(" walking");} else {Serial.println(" stopped");}}
                break;    
    case 'U':   USreact();      break; 
    case 'W':   WhiskerReact(); break; 
    case 'G':   BeardReact();   break;
    case 'v':   if (f_recording) { RecordCcmnd(); }    //so 'v' is recorded
                GetCcmnd();                            //get parameter
                switch (Ccmnd) 
                { case 'b':  bip();   break;
                  case 'e':  whee();  break;
                  case 'o':  whoa();  break;
                  default:   bip();   Ccmnd ='b';  break;
                }    // end switch
                break;                
    case 'w':   if (f_recording) { RecordCcmnd(); }    //so 'w' is recorded
                GetCcmnd();                            //get parameter
                makeCcmndDigit();                      //ensure '1'-'9'
                waitCcmndSecs();
                break;                                 // if recording Ccmnd will be recorded
    case 's':   if (f_recording) { RecordCcmnd(); }    //so 's' is recorded
                GetCcmnd();                            //get parameter
                if (Ccmnd=='u') { speedup();  break; }     // and if recording record 'u' 
                if (Ccmnd=='d') { speeddown();  break; }   // and if recording record 'd' 
                if (Ccmnd=='m') { rollspeedmax =rollspeed; pacespeedmax =pacespeed; break; }
                if (Ccmnd=='r') 
                { if (f_recording) { RecordCcmnd(); }  //so 'r' is recorded
                  GetCcmnd();                          //get parameter
                  if (Ccmnd=='m') { rollspeedmax =rollspeed; break; }
                  //else                 
                  makeCcmndDigit();                    //ensure '1'-'9'    
                  rollspeed =Ccmnd -'0';
                  break;                               // and if recording record digit
                }
                if (Ccmnd=='p') 
                { if (f_recording) { RecordCcmnd(); }  //so 'p' is recorded
                  GetCcmnd();                          //get parameter
                  if (Ccmnd=='m') { pacespeedmax =pacespeed; break; }
                  //else                 
                  makeCcmndDigit();                    //ensure '1'-'9'    
                  pacespeed =Ccmnd -'0';
                  break;                               // and if recording record digit 
                }
                //else                 
                makeCcmndDigit();                      //ensure '1'-'9'    
                rollspeed =max(1,Ccmnd -'0'); 
                pacespeed =max(1,Ccmnd -'0');       	
                break;                                 // and if recording record digit 
    case 't':   if (f_recording) { RecordCcmnd(); }    //so 't' is recorded
                GetCcmnd();                            //get parameter
                switch (Ccmnd)
                { case 'a':  turnAway();    break;
                  case 'm':  turnMemory();  break;
                  case 'o':  turnOther();   break;
                  case 'l': turnLight();   break;
                  case 'd': turnDark();    break;
                  case '@': if (f_recording) { RecordCcmnd(); }    //so '@' is recorded
                            GetCcmnd();                            //get parameter
                            switch (Ccmnd)
                            { case 'l':  turnAtLight();  break;
                              case 'd':  turnAtDark();   break;
                              default:   badkey();  if(!f_BeQuiet){Serial.println("bad key");}
                                         Ccmnd ='?';     //so if recording then '?' is recorded
                                         break;          //don't do anything 
                            }    // end switch
                  default:  turnMemory();   Ccmnd ='m';  break;
                }     // end switch case t
                break;                               
    case 'b':   if (f_recording) { RecordCcmnd(); }    //so 'b' is recorded
                GetCcmnd();                            //get parameter
                switch (Ccmnd)
                { case '#': f_recordC =false;
                            GetCcmnd();                            //get parameter
                            if( f_BeQuiet==1 ) { break; }     // don't change these if being quiet
                            if (Ccmnd>='0' && Ccmnd<='9')
                              { rgroup =Ccmnd;  EEPROM.write(Ergroup,rgroup);  break; }
                            if (Ccmnd>='A' && Ccmnd<='z') 
                              { rname =Ccmnd;  EEPROM.write(Ername,rname);  break; }
                            badkey();  break;
                  case 'a': if (f_recording) { RecordCcmnd(); }    //so 'a' is recorded
                            GetCcmnd();                            //get parameter
                            if(Ccmnd<'0' || Ccmnd>'9') { Ccmnd ='0'; break; }
                            if (Ccmnd=='9') {f_runDefault =true; break;}             // ## sets f_runDefault false
                            EEPROM.write(EautoAct,Ccmnd);
                            break;
                  case 'p': if (f_recording) { RecordCcmnd(); }    //so 'p' is recorded
                            GetCcmnd();                            //get parameter
                            makeCcmndDigit();                      //ensure '1'-'9'
                            paceby =(Ccmnd -'0') *2;  //gives a maximum of 18, default 15
                            break;
                  case 't': if (f_recording) { RecordCcmnd(); }    //so 't' is recorded
                            GetCcmnd();                            //get parameter
                            makeCcmndDigit();                      //ensure '1'-'9'
                            turnby =(Ccmnd -'0') *2;  //gives a maximum of 18, default 15
                            break;
                  case 'r': if (f_recording) { RecordCcmnd(); }    //so 'r' is recorded
                            GetCcmnd();                            //get parameter
                            makeCcmndDigit();                      //ensure '1'-'9'
                            rollby =(Ccmnd -'0') *2;  //gives a maximum of 18, default 15
                            break;                            
                  case 'q': f_BeQuiet =1;  break;           
                  case '@': if( f_BeQuiet==1 ) { break; }     // don't adjust if being quiet
                            AdjustServos();  break;           
                  default:  badkey();  if(!f_BeQuiet){Serial.println("bad key");}
                            Ccmnd ='?';     //so if recording then '?' is recorded
                            break;          //don't do anything
                }     // end switch
                break;                               
    case 'r':   f_recordC =false;
                redLEDon();
                if (!f_recording) 
                  { getAct();  if(Ccmnd=='.') { break; }  
                  setEEPROMindexes(Act);  f_recording =true; 
                  }
                break;
    case 'c':   f_recordC =false;  if (!f_recording) { copyAct(); }  break;	
    case 'l':   f_recordC =false;  if (!f_recording) { loadAct(); }  break;	
    case '?':   f_recordC =false;
                if (!f_recording) 
                  { GetCcmnd();                           //get parameter
                    if( f_BeQuiet==1 ) { break; }         // don't print if being quiet
                    switch (Ccmnd)
                    { case 'h':  printHelp();  break;     // print instructions
                      case '1':  // fall through
                      case '2':  // fall through
                      case '3':  // fall through
                      case '4':  // fall through
                      case '5':  // fall through
                      case '6':  // fall through
                      case '7':  // fall through
                      case '8':  Act =Ccmnd;  printAct();  break;
                      case 'p':  PrintAllActs();  break;
                      case '?':  PrintAllActs();  break;
                      case 'd':  DumpActs();  break;
                      case 'b':  printBehaviour();  break;
                      case 'm':  printMind();  break;      // - all Acts, Behaviour
                      default:   badkey();  if(!!f_BeQuiet){Serial.println("?");}  break;
                    }    // end switch               
                  }    // end if 
                break;
    case '#':   f_recordC =false;
                f_MsgForMe =1;
                f_hashcmnd =true;           // don't get a Play command here
                GetCcmnd();                 //get parameter
                f_hashcmnd =false;
                switch (Ccmnd)
                { case '*': f_MsgForMe =1;  f_BeQuiet =1;  break;  hashgroup =rgroup;  break;  //everybody listen
                  case '#': f_MsgForMe =1;  f_BeQuiet =0;                  //everybody stop
                            disable_walking();  Ccmnd ='.';  hashhashAt =EEPROMindex;
                            f_hashhashSTOP =true;  // so '.' gets processed
                            f_runDefault =false;
                            break;
                  case '<': f_doDefault =true;  f_hashhashSTOP =false;  enable_walking();  break;
                  case '>': if (hashhashAt!=-1)                //something to continue
                            { f_play =true;  enable_walking(); EEPROMindex =hashhashAt; }
                            f_hashhashSTOP =false;    
                            break;
                  case '?': delay((rgroup -'0')*50+(rname-'A')*10);
                            Serial.print(" "); Serial.print(rgroup); Serial.print(rname); 
                            break;
		              case '.': f_MsgForMe =0;  f_BeQuiet =1;  hashgroup =' ';     //end #session
			                      break;
                  default:  if (Ccmnd>='0' && Ccmnd<='9' ) { 
                              hashgroup =Ccmnd; 
                              if (hashgroup==rgroup) 
                                { f_MsgForMe =1;  f_BeQuiet =1;  }    //my group
                               else
                                { f_MsgForMe =0;  f_BeQuiet =1;  }    //not my group
                              break;
                              }
                            if (Ccmnd==rname && hashgroup==rgroup)  { f_MsgForMe =1;  f_BeQuiet =0;  break; }    //me
                            f_BeQuiet =1;      // any other key             //not for me 
                            break;
                }
                break;              
                
    default:    f_recordC =false;    //don't record bad key		
                badkey();  if(!f_BeQuiet){ Serial.println("bad key"); }  break;
  }    // end switch
	
Record:	
  if (f_recording  && f_recordC) { RecordCcmnd(); } 
  
}    
//== FUNCTIONS ==============================================

void GetCcmnd()	       //reads Serial or playing Act until Ccmnd != 0, prints Ccmnd
{ Ccmnd =0;
  while(Ccmnd==0)
  { if(f_recording)  
    { while(!Serial.available()) {}       //wait for Serial
      Ccmnd =Serial.read();  bip(); 
    } 
    else         //if(!f_recording)
    { if(Serial.available()) 
      { Ccmnd =Serial.read();            //over-ride if Serial, null ignored
        if(!f_MsgForMe && Ccmnd!='#') { Ccmnd =0; }     //discard messages for others
        else { bip(); }
      }  
      else 
      { if(!f_hashcmnd)         //don't get a Play character if in the middle of a hash command   
        { if(f_play)
          { Ccmnd =PlayAct();             //get Act Ccmnd 
          }
        }  
      }
    }  //end if(!f_recording)                                               
  }  //end while Ccmnd==0
  if( !f_BeQuiet ){ Serial.print(Ccmnd); }
}   
//============================  
void RecordCcmnd()	
{ EEPROM.write(EEPROMindex,Ccmnd);
  EEPROMindex++;
  if (EEPROMindex>=ActEnd) { f_recording =false;  EEPROM.write(ActEnd,'.');  badkey(); }     //terminated string 
}  
//============================  

void Experiment()       //until Quit
{ while(true)
  { 
    //put your own routine here e.g.
    rollspeed =4;
    pacespeed =4;
    forward();       // Walk one step forwards
    forward();       // Walk one step forwards
    forward();       // Walk one step forwards
    whee(); 
    turnRight();
    turnRight();
    turnRight();    
    whee(); 
    rollspeed =2;
    pacespeed =2;
    turnLeft();
    turnLeft();
    turnLeft();
    whee(); 
    rollspeed =1;
    pacespeed =1;
    backward();      // Walk one step backwards
    backward();      // Walk one step backwards
    backward();      // Walk one step backwards
    whee();    
    whee();    
    whee();    
    if(Quit()) { break; } 
  }	// end while
}
//----------------------------
void Xplore()         //Wander() until Quit
{ while(true)
  { Wander();
    if(Quit()) { break; } 
  }	// end while
}
//----------------------------  
void makeCcmndDigit()      //ensure 1-9
{ if (Ccmnd<'1' || Ccmnd>'9') { Ccmnd ='1'; } //default
}
//----------------------------  
void waitCcmndSecs()   //read delay time from Act and wait
{ if (Ccmnd<'1' || Ccmnd>'9') { Ccmnd ='1'; } //default
  byte cmnd =Ccmnd -'0';                          // ASCII to numeric
  delay(cmnd *1000);
}  
//----------------------------  
void printMind()
{ PrintAllActs();
  printBehaviour();
}
//----------------------------  
void printBehaviour()
{ Serial.println();                
  Serial.println(thisprog); // so we know which program is running
  Serial.print("robot ");      Serial.print(rgroup);   Serial.print(rname); 
                               Serial.print(" MsgForMe=");  Serial.print(f_MsgForMe); 
                               Serial.print(" BeQuiet=");   Serial.println(f_BeQuiet);  
  Serial.print(f_walking);     Serial.println(" walking"); 
  Serial.print(char(EEPROM.read(EautoAct))); Serial.print(" autoAct,  "); Serial.print("rerun "); if (f_runDefault==1) { Serial.print("On"); } else { Serial.print("Off"); } Serial.println("  (default Off)"); 
  Serial.print(rollspeed);     Serial.println(" rollspeed");
  Serial.print(pacespeed);     Serial.println(" pacespeed");
  Serial.print(rollspeedmax);  Serial.println(" rollspeedmax");
  Serial.print(pacespeedmax);  Serial.println(" pacespeedmax");  
  Serial.print(rollby);        Serial.print('(');        Serial.print(rollby/2);        Serial.print(')');        Serial.println(" rollby");
  Serial.print(paceby);        Serial.print('(');        Serial.print(paceby/2);        Serial.print(')');        Serial.println(" paceby");
  Serial.print(turnby);        Serial.print('(');        Serial.print(turnby/2);        Serial.print(')');        Serial.println(" turnby");
  Serial.print(rollC);         Serial.println(" rollC");    
  Serial.print(paceC);         Serial.println(" paceC");    
}  
//----------------------------  
void DumpActs()        //Dump Acts, Print without names and length
{ for(Act ='1'; Act<='8'; Act++)
  { setEEPROMindexes(Act);
    Serial.println();
    Ccmnd =EEPROM.read(EEPROMindex++);
    // -1 (=255) is uninitialised EEPROM value
    while(Ccmnd !='.' && Ccmnd !=-1) { Serial.print(Ccmnd); Ccmnd =EEPROM.read(EEPROMindex++); }
  }
  for(Act ='1'; Act<='8'; Act++) 
  { epage =2;  setEEPROMindexes(Act);
    Serial.println();
    Ccmnd =EEPROM.read(EEPROMindex++);
    // -1 (=255) is uninitialised EEPROM value
    while(Ccmnd !='.' && Ccmnd !=-1) { Serial.print(Ccmnd); Ccmnd =EEPROM.read(EEPROMindex++); }
  }
  Serial.println();
}		
//----------------------------  
void loadAct()
{ redLEDon();  
  getAct();                         //Ccmnd ->'.', '1' - '8'
  if (Ccmnd!='.')
  { setEEPROMindexes(Act);
    while(true) 
    { while(!Serial.available()) {}  //wait for Serial
      Ccmnd =Serial.read();  Serial.print(Ccmnd);
      if(Ccmnd=='.' || Ccmnd==Esc) { break; }
      EEPROM.write(EEPROMindex,Ccmnd);  EEPROMindex++;
      if (EEPROMindex>=ActEnd) { badkey();  break; }     //ActEnd =EEPROMindex +31;   
    }
    EEPROM.write(EEPROMindex,'.');                        //terminated string 
  }
}
//----------------------------  
void copyAct()
{ getAct();
  if (Ccmnd!='.')
  { setEEPROMindexes(Act);
    int fromEEPROMindex =EEPROMindex;  
    int fromActEnd =ActEnd;
    getAct();
    if (Ccmnd!='.')
    { setEEPROMindexes(Act);
      for(byte i =0; i<=fromActEnd -fromEEPROMindex; i++)
      { EEPROM.write(EEPROMindex +i,EEPROM.read(fromEEPROMindex +i)); }
    } 
  }	
}
//----------------------------
char PlayAct() 
{ char _Ccmnd =EEPROM.read(EEPROMindex++);
  if(_Ccmnd==255 || _Ccmnd==-1) _Ccmnd ='.';     //uninitialised EEPROM value, don't play it, change to '.'
  return _Ccmnd;
}  
//----------------------------
void PrintAllActs()
{ for(Act ='1'; Act<='8'; Act++) { epage =1; printAct(); }  Serial.println(); 
  for(Act ='1'; Act<='8'; Act++) { epage =2; printAct(); }  Serial.println(); 
}
//----------------------------
void printAct()
{ Serial.println();
  Serial.print("Act");
  if(epage==2) { Serial.print('0'); }    //for logical page0 Acts
  Serial.print(Act);
  Serial.print(" ");
  setEEPROMindexes(Act);
  Ccmnd =EEPROM.read(EEPROMindex++);
  // -1 (=255) is uninitialised EEPROM value
  while(Ccmnd !='.' && Ccmnd !=-1) { Serial.print(Ccmnd); moves++; Ccmnd =EEPROM.read(EEPROMindex++); }
  EEPROMindex -=1;        //step back to end of record just in case playing
  Serial.print(". - ");
  Serial.print(moves);    //there are moves which take more than 1 character  
  Serial.print(" bytes"); //so the space taken in EEPROM is really bytes
  moves =0;	
}
//----------------------------  
void getAct()      //called when recording, loading, printing and copying Acts, Ccmnd ->'.', '1' - '8'
{ Ccmnd =0;
  do
  { if(Serial.available()) 
    { Ccmnd =Serial.read();   Serial.print(Ccmnd);
      switch (Ccmnd) 
      { case Esc:   Ccmnd ='.';     //[Esc] key, fall through to '.'
        case '.':  Serial.print(">");  break;     //quit, print ready prompt
        case '0':  epage =2;  Ccmnd =0;  break;  //do it again to read Act
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':  Act =Ccmnd;  break;
        default: badkey(); Serial.print(" enter Act or '.'"); Ccmnd =0;	
      }  //end case
    } //end if Serial
  } while(Ccmnd==0);
  Serial.print(Ccmnd);
}    
//----------------------------
void setEEPROMindexes(char Act)     // set EEPROM pointers
{ actIndex =Act -'1';               // ASCII to numeric,  Act 1 == actIndex 0
  EEPROMindex =(256 *epage) +(actIndex*32);  
  ActEnd =EEPROMindex +31;
  epage =1;            //set to default page, Acts 1 - 8 
}
//----------------------------
void badkey()     // indicate invalid key
{ digitalWrite(RwhiskerLEDpin_, LOW);// whisker LED ON
  delay(100);
  digitalWrite(RwhiskerLEDpin_, HIGH);// whisker LED OFF    
  digitalWrite(LwhiskerLEDpin_, LOW);// whisker LED ON
  delay(100);
  digitalWrite(LwhiskerLEDpin_, HIGH);// whisker LED OFF  
  whoa();  
}  
//----------------------------
void printHelp()
{ Serial.println();
  for (int i = 0; i < (sizeof(help_table)/sizeof(int)); i++) 
  //sizeof gives bytes so divide by sizeof(int) to get number of elements
  {
    // see http://arduino.cc/en/Reference/PROGMEM
    strcpy_P(helpbuffer, (char*)pgm_read_word(&(help_table[i]))); // Necessary casts and dereferencing
    Serial.println( helpbuffer );
  }  
}
//----------------------------
void USreact()     // read Ultrasonic sensor and react to objectRange using avoidUObjects() behaviour rules
{ objectRange =dist_HC_SR04();
  if( !f_BeQuiet ) { Serial.println(); }
  if( !f_BeQuiet ) { Serial.print("Ultrasonic distance ="); }
  if( !f_BeQuiet ) { Serial.println(objectRange); }
  avoidUObjects();
}
//----------------------------
void WhiskerReact()     // read Whisker sensors and avoid obstacles (if any) using avoidObstacles() behaviour rules
{ readWhiskers(); 
  queryObstaclesLR();
  avoidObstaclesLR();
}
//----------------------------
void BeardReact()     // read Beard sensors and avoid holes (if any) using avoidHoles() behaviour rules
{ readBeard();
  queryEdgeLR();
  avoidHolesLR(); 
}
//----------------------------
void beAlive()         // the loop() from B_PM22_BeAlive
{ while(true)
  { switch (random(9))
    { case 0: WanderSteps(random(10)); break;    //uses all sensors
      case 1: rock(random(3)); break;
      case 2: shuffle(random(3)); break;
      case 3: whoa(); break;
      case 4: whee(); break;
      case 5: rollspeed =random(1,4); break;
      case 6: pacespeed =random(1,6); break;
      case 7: RightStep(random(6)); break;
      case 8: LeftStep(random(6)); break;
    } // end switch
    if( Quit() ) { break; }
  }	// end while
}
//---------------------------
boolean Quit()          //check for Quit
{ if( Serial.available() ) 
  { Ccmnd =Serial.peek(); 
    if( Ccmnd=='.' || Ccmnd==Esc )
      { return true; }
     else
      { return false; }
  }  
}
//----------------------------
void bip()            // make a bip sound
{ beep(voicePin,1500,50); }
//----------------------------
#ifdef BambinoMM
void redLEDdim()
{ analogWrite(redLEDpin_,254); }  //redLED, LOW=on so 255 is off 
//----------------------------
void redLEDon()
{ digitalWrite(redLEDpin_,LOW); }  
//----------------------------
void redLEDoff()
{ digitalWrite(redLEDpin_,HIGH); }  
//---------------------------- 
//BambinoMM does not have Whisker sensors
//---------------------------- 
#else
void redLEDon()
{ digitalWrite(redLEDpin,HIGH); }  
//----------------------------
void redLEDoff()
{ digitalWrite(redLEDpin,LOW); }  
//----------------------------
void whiskerLEDsOff()
{ digitalWrite(RwhiskerLEDpin_, HIGH);                             // whisker LED OFF
  digitalWrite(LwhiskerLEDpin_, HIGH);                             // whisker LED OFF
  }  
//----------------------------  
void whiskerLEDsDim()
{ analogWrite(RwhiskerLEDpin_,254);   //Right whiskerLED, LOW=on so 255 is off
  analogWrite(LwhiskerLEDpin_,254);   //Left whiskerLED, LOW=on so 255 is off
  }
#endif
//===========================================================
