// Bambino
// TAB FILE > movement34.ino

//     MOVEMENT - forward(), backward(), turnRight(), turnLeft(), 
//                halt(), 
//                rollCentre(), rollLeft(), rollRight(),
//                paceCentre(), paceLeftForward(),  paceRightForward(), 
//                              paceLeftBackward(), paceRightBackward(), 
//                              turnLeftForward(),  turnRightForward(), 
//                              turnLeftBackward(), turnRightBackward(), 
//                rollmove(), pacemove()
//== NEW ====================================================
/*
movement34.ino - turnRightForward(), turnLeftForward(), turnRightBackward(), turnLeftBackward() 
boolean f_turning =0; // controls pace in paceLeftForward() and paceRightForward() when turning
*/
//== CHANGED ================================================
/*
(skills turnAway(), turnMemory(), turnOther() in  skills34.ino)
movement34.ino - turnRight()	  //now uses turnRightForward(), turnLeftForward(), turnRightBackward(), turnLeftBackward(), sets f_turning  
movement34.ino - turnLeft()	   	//now uses turnRightForward(), turnLeftForward(), turnRightBackward(), turnLeftBackward(), sets f_turning
movement34.ino - paceLeftForward(), paceRightForward() test f_turning
*/
//===========================================================

//== MOVEMENT ===============================================
void forward()       // Walk one step forwards
{ f_forwards =1;
  if (paceat<paceC)
    { rollRight();  paceLeftForward();  rollCentre(); } 
   else
    { rollLeft();  paceRightForward();  rollCentre(); } 
  } 
//----------------------------
void backward()       // Walk one step backwards
{ f_forwards =0;
  if (paceat>paceC)
    { rollRight();  paceLeftBackward();  rollCentre(); } 
   else
    { rollLeft();  paceRightBackward();  rollCentre(); } 
  } 
//----------------------------
void turnRight()
{ // Turn right.
  // Bambino turns by sliding its feet in a 'tank' or 'skid' turn.
  // to turn right, the left foot must be forward. 
  // If it isn't then a step has to be made.
  f_turning =1;                // controls pace in turns
  if (paceat >= paceC)          // ie left foot forward       
    { turnRightForward(); }
   else
    { if (f_forwards) { forward(); } else { backward(); }
      turnRightForward();
      }
  f_TurnedRight =1;
  f_turning =0;
  }  
//----------------------------
void turnLeft()
{ // Turn left.
  // Bambino turns by sliding its feet in a 'tank' or 'skid' turn.
  // to turn right, the left foot must be forward. 
  // If it isn't then a step has to be made.
  f_turning =1;                // controls pace in turns
  if (paceat <= paceC)          // ie right foot forward      
    { turnLeftForward(); }
   else
    { if (f_forwards) { forward(); } else { backward(); }
      turnLeftForward();
      }
  f_TurnedRight =0;  
  f_turning =0;
  }
//----------------------------
void halt()                      // halt with both feet together
{ if (f_forwards)                // if going forwards
  { if (paceat > paceC)          // if left foot forward stand on left foot else right foot      
    { rollLeft(); } else { rollRight(); }     //
    }
   else                           // if going backwards
    { if (paceat > paceC)          // if left foot forward stand on right foot else left foot      
      { rollRight(); } else { rollLeft(); }
      } 
  paceCentre(); 
  rollCentre();
  }  
//----------------------------
void rollCentre()        { rollto =rollC;          rollmove(); }
void rollRight()         { rollto =rollC +rollby;  rollmove(); }
void rollLeft()          { rollto =rollC -rollby;  rollmove(); }
void paceCentre()        { paceto =paceC;          pacemove(); }
void paceRightForward()  { if (f_turning==1) {paceto =paceC -turnby; } else {paceto =paceC -paceby; } pacemove(); }
void paceLeftForward()   { if (f_turning==1) {paceto =paceC +turnby; } else {paceto =paceC +paceby; } pacemove(); }
void paceRightBackward() { paceLeftForward(); }
void paceLeftBackward()  { paceRightForward(); }
void turnRightForward()  { paceto =paceC -turnby;  pacemove(); }
void turnLeftForward()   { paceto =paceC +turnby;  pacemove(); }
void turnRightBackward() { turnLeftForward(); }
void turnLeftBackward()  { turnRightForward(); }
//----------------------------
void rollmove()    // do roll move  
{
  if (rollspeed==0) {rollspeed =1;}     // dont hang if 0
  if (rollto > rollat)
    { for (rollat =rollat; rollat <rollto; rollat +=rollspeed)  {ServoPulse(servoRollPin,rollat); delay(Servoframe);} }  
   else     
    { for (rollat =rollat; rollat >rollto; rollat -=rollspeed)  {ServoPulse(servoRollPin,rollat); delay(Servoframe); } }
  rollat =rollto; ServoPulse(servoRollPin,rollat); delay(Servoframe);      // make sure servo is at rollto for speed >1
  }
//----------------------------
void pacemove()    // do pace move
{ if (pacespeed==0) {pacespeed =1;}     // dont hang if 0 
  if (paceto > paceat)
    { for (paceat =paceat; paceat <paceto; paceat +=pacespeed)  {ServoPulse(servoPacePin,paceat); delay(Servoframe); } }  
   else     
    { for (paceat =paceat; paceat >paceto; paceat -=pacespeed)  {ServoPulse(servoPacePin,paceat); delay(Servoframe); } }
    paceat =paceto; ServoPulse(servoPacePin,paceat); delay(Servoframe);    // make sure servo is at paceto for speed >1
  }
//===========================================================
