// Bambino
// TAB FILE > system42.ino

//     SYSTEM - disable_walking(), enable_walking(), toggle_f_walking(), initialiseEEPROM()

//== NEW ====================================================
/*
*/
//== CHANGED ================================================
/*
disable_walking(), enable_walking() toggle_f_walking()
  deleted   EEPROM.write(Ef_walking,f_walking);   // save new state  
toggle_f_walking()
  deleted   f_walking =EEPROM.read(Ef_walking);   // read old state   
  deleted   EEPROM.write(Ef_walking,f_walking);   // save new state  
void disable_walking()                  // disable walking
{  if(f_walking) {Srollat =rollat; Spaceat =paceat;}
void enable_walking()                   // enable walking
{ if(!f_walking) {rollat =Srollat; paceat =Spaceat;}
void toggle_f_walking()                 // toggles on reset
*/
//===========================================================


//== SYSTEM =================================================
void disable_walking()                  // disable walking
{ if(f_walking) {Srollat =rollat; Spaceat =paceat;}
  f_walking =false;
}  
//-----------------------------------------------------------     
void enable_walking()                   // enable walking
{ if(!f_walking) {rollat =Srollat; paceat =Spaceat;}
  f_walking =true;
}  
//-----------------------------------------------------------     
void toggle_f_walking()
{ if(f_walking) { disable_walking(); } else { enable_walking(); }   
}  
//-----------------------------------------------------------     
void initialiseEEPROM()
{
// write defaults to EEPROM
  EEPROM.write(Ef_walking,0);    // 0 =>stopped, 1 =>walking
  EEPROM.write(ErollC,90);       // nominal roll centre = 90 degrees (ie 1500us) => upright
  EEPROM.write(EpaceC,90);       // nominal pace centre = 90 degrees (ie 1500us) => feet together
//rollbymax absolute max is 90+-20, above that the tilt rods hit the body
  EEPROM.write(Erollby,15);      // nominal Roll for walking
//pacebymax absolute max is 90+-20, above that the tilt rods hit the rear femur 
//and the horn screws hit the leg body
  EEPROM.write(Epaceby,15);      // nominal Pace for walking
  //EEPROM.write(Erollmin,70);     // nominal minimum roll value, not used at present     
  //EEPROM.write(Erollmax,110);    // nominal maximum roll value, not used at present
  //EEPROM.write(Epacemin,75);     // nominal minimum pace value, not used at present 
  //EEPROM.write(Epacemax,105);    // nominal maximum pace value, not used at present
  }
//===========================================================
