// Bambino
// TAB FILE > mind46.ino

//     MIND - getMind(), saveMind(),
//            initEEPROM_GWU(), initialiseEEPROM(), initBehaviour8(), initialiseEEPROMbehaviours1to7()  
//===========================================================
//NEW
//void initEEPROM_GWU()
//== Mind ==================================================

void getMind()           //"b"<behaviour>
{
  f_walking    =EEPROM.read(BehaviourEbase +Es31f_walking);
  rollC        =EEPROM.read(BehaviourEbase +Es30rollC);     // initialise rollC from EEPROM, stand upright value
  paceC        =EEPROM.read(BehaviourEbase +Es29paceC);     // initialise paceC from EEPROM, feet together value
  rollby       =EEPROM.read(BehaviourEbase +Es28rollby);    // set to EEPROM value
  paceby       =EEPROM.read(BehaviourEbase +Es27paceby);    // set to EEPROM value
  turnby       =paceby;
  //23-26 never altered
  rgroup       =EEPROM.read(BehaviourEbase +Es22rgroup);
  rname        =EEPROM.read(BehaviourEbase +Es21rname);
  autoAct      =EEPROM.read(BehaviourEbase +Es20autoAct);
  SonarAwareAt =EEPROM.read(BehaviourEbase +Es19SonarAwareAt);
  SonarTooNear =EEPROM.read(BehaviourEbase +Es18SonarTooNear);
  f_cm         =EEPROM.read(BehaviourEbase +Es17f_cm);
  rollspeedmax =EEPROM.read(BehaviourEbase +Es16rollspeedmax);
  pacespeedmax =EEPROM.read(BehaviourEbase +Es15pacespeedmax);
  rollspeed    =EEPROM.read(BehaviourEbase +Es14rollspeed);
  pacespeed    =EEPROM.read(BehaviourEbase +Es13pacespeed);
  f_bG         =EEPROM.read(BehaviourEbase +Es12Greact);
  f_bW         =EEPROM.read(BehaviourEbase +Es11Wreact);
  f_bU         =EEPROM.read(BehaviourEbase +Es10Ureact);      
  f_bAutoSense =EEPROM.read(BehaviourEbase +Es09AutoSense);
  //0 '@' indicates current behaviour, otherwise '.' 
}
//-----------------------------------------------------------     
void saveMind()         //"bs"<behaviour>
{ // slotbase so current BehaviourEEbase is not changed
  EEPROM.write(slotbase +31, f_walking);
  EEPROM.write(slotbase +30, rollC);
  EEPROM.write(slotbase +29, paceC);
  EEPROM.write(slotbase +28, rollby);
  EEPROM.write(slotbase +27, paceby);
  //23-26 never altered
  EEPROM.write(slotbase +22, rgroup);
  EEPROM.write(slotbase +21, rname);
  EEPROM.write(slotbase +20, autoAct);
  EEPROM.write(slotbase +19, SonarAwareAt);
  EEPROM.write(slotbase +18, SonarTooNear);
  EEPROM.write(slotbase +17, f_cm);
  EEPROM.write(slotbase +16, rollspeedmax);
  EEPROM.write(slotbase +15, pacespeedmax);
  EEPROM.write(slotbase +14, rollspeed);
  EEPROM.write(slotbase +13, pacespeed);
  EEPROM.write(slotbase +12, f_bG);
  EEPROM.write(slotbase +11, f_bW);
  EEPROM.write(slotbase +10, f_bU);
  EEPROM.write(slotbase +9,  f_bAutoSense);
  //0 '@' indicates current behaviour, otherwise '.' 
}
//-----------------------------------------------------------     
void initEEPROM_GWU()
{ //if needed initialise new bG,bW,bU in behaviour slots 1-8
  for (BehaviourEbase =0; BehaviourEbase <224; BehaviourEbase +=32 )  //test all slots 
  { if (EEPROM.read(BehaviourEbase +Es12Greact)==255)       //test if bG not initialised
    { EEPROM.write(BehaviourEbase +Es12Greact, 0 );
      EEPROM.write(BehaviourEbase +Es11Wreact, 0 );
      EEPROM.write(BehaviourEbase +Es10Ureact, 0 );
      EEPROM.write(BehaviourEbase +Es09AutoSense, 0 );
    }    
  }
}  
//-----------------------------------------------------------     
void initialiseEEPROM()     //Behaviour slot 8
{
  initBehaviour8();                   //init EEPROM behaviour8
  initialiseEEPROMbehaviours1to7();   //copy behaviour8 to other behaviours
}
//-----------------------------------------------------------     

void initBehaviour8()             //init EEPROM behaviour8
{
  EEPROM.write(E255f_walking,0);    // 0 =>stopped, 1 =>walking
  EEPROM.write(E254rollC,90);       // nominal roll centre = 90 degrees (ie 1500us) => upright
  EEPROM.write(E253paceC,90);       // nominal pace centre = 90 degrees (ie 1500us) => feet together
  //rollbymax absolute max is 90+-20, above that the tilt rods hit the body
  EEPROM.write(E252rollby,15);      // nominal Roll for walking
  //pacebymax absolute max is 90+-20, above that the tilt rods hit the rear femur 
  //and the horn screws hit the leg body
  EEPROM.write(E251paceby,15);      // nominal Pace for walking
  //EEPROM.write(E250rollmin,70);     // nominal minimum roll value, not used at present     
  //EEPROM.write(E249rollmax,110);    // nominal maximum roll value, not used at present
  //EEPROM.write(E248pacemin,75);     // nominal minimum pace value, not used at present 
  //EEPROM.write(E247pacemax,105);    // nominal maximum pace value, not used at present
  //core parameters of Slot8 now initialised   
   
  //initialise other slot8 parameters if uninitialised 	
  if(EEPROM.read(E246rgroup)==255)      {EEPROM.write(E246rgroup,'0');}
  if(EEPROM.read(E245rname)==255)       {EEPROM.write(E245rname, 'z');}
  if('0'>EEPROM.read(E244autoAct) || '8'<EEPROM.read(E244autoAct)) 
                                         {EEPROM.write(E244autoAct,     '0');}
  if(EEPROM.read(E243SonarAwareAt)==255) {EEPROM.write(E243SonarAwareAt,5  );}
  if(EEPROM.read(E242SonarTooNear)==255) {EEPROM.write(E242SonarTooNear,2  );}
  if(EEPROM.read(E241f_cm)==255)         {EEPROM.write(E241f_cm,       true);}        
  if(EEPROM.read(E240rollspeedmax)==255) {EEPROM.write(E240rollspeedmax,4  );}
  if(EEPROM.read(E239pacespeedmax)==255) {EEPROM.write(E239pacespeedmax,6  );}
  if(EEPROM.read(E238rollspeed)==255)    {EEPROM.write(E238rollspeed,   1  );}
  if(EEPROM.read(E237pacespeed)==255)    {EEPROM.write(E237pacespeed,   1  );}
  if(EEPROM.read(224)==255)            {EEPROM.write(224,           '@');}
}
//-----------------------------------------------------------     
void initialiseEEPROMbehaviours1to7()
//in earlier programs to 45 slot8 was the only behaviour
{ for (BehaviourEbase =0; BehaviourEbase<224; BehaviourEbase +=32 )           //test first 7 slots 
  { if(EEPROM.read(BehaviourEbase) != '.' && EEPROM.read(BehaviourEbase) != '@' )  //test address0 for '.' or '@'
      { for (byte i =1; i<32; i++)
        { EEPROM.write(BehaviourEbase +i, EEPROM.read(224 +i) );               //copy from slot 8
          EEPROM.write(BehaviourEbase,'.');                                    //not default behaviour
        }
      }
   }
}   
//-----------------------------------------------------------     
