// Bambino
// TAB FILE > varsCons46.h

/*== NEW ====================================================
EEPROM slots 12,11,10,9
*/
/*== CHANGED=================================================
*/
//===========================================================
//EEPROM addresses for behaviour8
const byte E255f_walking    =255;  //31 - 0,1  init -> f_walking
const byte E254rollC        =254;  //30 - init -> rollC
const byte E253paceC        =253;  //29 - init -> paceC
const byte E252rollby       =252;  //28 - init -> rollby
const byte E251paceby       =251;  //27 - init -> paceby, turnby
const byte E250rollmin      =250;  //26 - nominal minimum roll value, not used at present   
const byte E249rollmax      =249;  //25 - nominal maximum roll value, not used at present  
const byte E248pacemin      =248;  //24 - nominal minimum roll value, not used at present  
const byte E247pacemax      =247;  //23 - nominal maximum roll value, not used at present   
const byte E246rgroup       =246;  //22 - 'A-Z a-z'  init(A) -> rgroup 
const byte E245rname        =245;  //21 - '0-9'      init(0) -> rname
const byte E244autoAct      =244;  //20 - '0-8' 
const byte E243SonarAwareAt =243;  //19 - 1-9  init(5) -> SonarAwareAt
const byte E242SonarTooNear =242;  //18 - 1-9  init(2) -> SonarTooNear
const byte E241f_cm         =241;  //17 - true, false  init
const byte E240rollspeedmax =240;  //16 - init
const byte E239pacespeedmax =239;  //15 - init
const byte E238rollspeed    =238;  //14 - 1-9  init
const byte E237pacespeed    =237;  //13 - 1-9  init
const byte E236Greact       =236;  //12 - 0,1  Ground     react 1=ON
const byte E235Wreact       =235;  //11 - 0,1  Whiskers   react 1=ON
const byte E234Ureact       =234;  //10 - 0,1  Ultrasonic react 1=ON
const byte E233autoSense    =233;  // 9	- 0,1  auto sense 1=ON
// 224 is default behaviour marker

//addresses within a slot
const byte Es31f_walking    =31;
const byte Es30rollC        =30;   // adjust servos
const byte Es29paceC        =29;   // adjust servos
const byte Es28rollby       =28;   // adjust servos
const byte Es27paceby       =27;   // adjust servos
const byte Es26rollmin      =26;   // adjust servos
const byte Es25rollmax      =25;   // adjust servos
const byte Es24pacemin      =24;   // adjust servos
const byte Es23pacemax      =23;   // adjust servos
const byte Es22rgroup       =22;
const byte Es21rname        =21;
const byte Es20autoAct      =20;
const byte Es19SonarAwareAt =19;   //'bus'
const byte Es18SonarTooNear =18;   //'bus'
const byte Es17f_cm         =17;
const byte Es16rollspeedmax =16;
const byte Es15pacespeedmax =15;
const byte Es14rollspeed    =14;
const byte Es13pacespeed    =13;
const byte Es12Greact       =12;  //12 - 0,1  Ground     react 1=ON
const byte Es11Wreact       =11;  //11 - 0,1  Whiskers   react 1=ON
const byte Es10Ureact       =10;  //10 - 0,1  Ultrasonic react 1=ON
const byte Es09AutoSense    =9;   // 9 - 0,1  auto sense 1=ON
// 0 is default behaviour marker

//== VARIABLES and CONSTANTS ================================ 
//BEHAVIOUR
char autoAct ='0' ;
byte SonarTooNear ;   // init =EEPROM(2), 'bu(m)-', units 50mm/2inch, objects nearer will be considered as Too Near and avoided  
byte SonarAwareAt ;   // init =EEPROM(5), 'bu(m)+', units 50mm/2inch, objects nearer will avoided, objects farther away will be ignored
/*these behaviour variable are declared below
byte rollC =90;      // roll centre = 90 degrees (ie 1500us) => upright
byte paceC =90;      // pace centre = 90 degrees (ie 1500us) => feet together
byte Servoframe =20; // Servo frame rate millisecs
byte rollby ;        // roll angles about rollC
byte paceby ;        // pace angles about paceC
byte turnby;         // servo turn angles about paceC
byte rollspeed ;     // roll servo speed  
byte pacespeed ;     // pace servo speed
byte rollspeedmax ;  // max speed for speedup()
byte pacespeedmax ;  // max speed for speedup()
*/
//MIND                       
boolean f_walking ;       // 1=> walking enabled , 0=> walking disabled
boolean f_bv =0;          //verbose, light level reporting of sensors, 0=off, 1=on
boolean f_BeQuiet ;       // 1-> status messages off
boolean f_MsgForMe ;      // 0-> messages are for other robots 
boolean f_hashcmnd    =0 ;// processing a hash command
boolean f_hashhashSTOP ;  // ##Stop from external commander
boolean f_TurnedRight ;   // 1=> last turn was Right, 0=> last turn was Left 
boolean f_forwards    =1 ;// current direction, 1=>forwards, 0=>backwards, controls step direction in turns
boolean f_turning     =0 ;// controls pace in paceRightForward()) and paceRightBackwards() when turning,   f_turning =1 =>turning
boolean f_AtLight ;       // true if facing Light
boolean f_AtDark ;        // true if facing Dark
boolean f_holeRight ;     // 0=> no hole, 1=> hole eg a table edge,  
boolean f_holeLeft ;      // 0=> no hole, 1=> hole eg a table edge
boolean f_obstacleRight ; // 0=> no obstacle, 1=> obstacle 
boolean f_obstacleLeft ;  // 0=> no obstacle, 1=> obstacle
byte cmnd =0 ;            // current command     
char rname ;         // robot name
char rgroup ;        // robot group
char hashgroup ;     // current hash group  
//SERVOS
//Servo values are in units of 1 degree, 0 - 180, centre at 90"
byte rollC =90;      // roll centre = 90 degrees (ie 1500us) => upright
byte paceC =90;      // pace centre = 90 degrees (ie 1500us) => feet together
byte Servoframe =20; // Servo frame rate millisecs
byte rollat ;        // Roll servo position, +ve roll to right 
byte paceat ;        // Pace servo position, +ve left foot forwards
byte rollby ;        // roll angles about rollC
byte paceby ;        // pace angles about paceC
byte turnby;         // servo turn angles about paceC
byte rollspeed ;     // roll servo speed  
byte pacespeed ;     // pace servo speed
byte rollspeedmax ;  // max speed for speedup()
byte pacespeedmax ;  // max speed for speedup()
byte rollto ;        // roll servo value to move to
byte paceto ;        // pace servo value to move to
byte Srollat ;       // remember rollat when walking disabled
byte Spaceat ;       // remember paceat when walking disabled
//== SENSORS ================================================
//Eyes
int ReyeLight ;      // light level read from R whisker light sensors, integer values between 0 and 1023
int LeyeLight ;      // light level read from L whisker light sensors, integer values between 0 and 1023
const byte LeftRightLightTurnThreshold  =10 ;  // difference% between LeyeLight and ReyeLight for a Light turn
//===========================================================
//Whiskers
int RwhiskerLight;   // reading from Right whisker sensor, LED on,  integer values between 0 and 1023
int LwhiskerLight ;  // reading from Left whisker sensor,  LED on,  integer values between 0 and 1023
int RwhiskerDark ;   // reading from Right whisker sensor, LED off, integer values between 0 and 1023
int LwhiskerDark ;   // reading from Left whisker sensor,  LED off, integer values between 0 and 1023
int RwhiskerDifference ; // difference between RwhiskerLight and RwhiskerDark
int LwhiskerDifference ; // difference between LwhiskerLight and LwhiskerDark
const byte obstacleThresholdRight =20 ;  // difference between RwhiskerLight and RwhiskerDark for an obstacle
const byte obstacleThresholdLeft  =20 ;  // difference between LwhiskerLight and LwhiskerDark for an obstacle
//===========================================================
//Beard
int RbeardLight ;    // reading from Right beard sensor, LED on,  integer values between 0 and 1023
int LbeardLight ;    // reading from Left beard sensor,  LED on,  integer values between 0 and 1023
int RbeardDark ;     // reading from Right beard sensor, LED off, integer values between 0 and 1023
int LbeardDark ;     // reading from Left beard sensor,  LED off, integer values between 0 and 1023
int RbeardDifference ; // difference between RbeardLight and RbeardDark
int LbeardDifference ; // difference between LbeardLight and LbeardDark
const byte holeThresholdRight =10 ;      // difference between RbeardLight and RbeardDark for a hole
const byte holeThresholdLeft  =10 ;      // difference between LbeardLight and LbeardDark for a hole 
//===========================================================
// Ultrasonic module HC-SR04
  // According to Parallax's datasheet for the PING))), 
  // See: http://www.parallax.com/dl/docs/prod/acc/28015-PING-v1.3.pdf
  // sound travels at 1130 feet per second, i.e. 73.746 microseconds per inch
  // (or the speed of sound is 340 m/s or 29 microseconds per centimeter).
  // This gives the distance travelled by the ping, outbound and return,
  // so we divide by 2 to get the distance of the obstacle
  // and then divide by 29 to get cm or divide by 73.746 to get inches,
  // i.e. divide by 2*29=58 to get cm, 
  // or divide by 2*73.746=147.492 =>147 to get inches.
  // Note the output of the HC_SR04 never goes LOW unless an echo is received.
  // The default time-out for pulseIn() is 1 second (Arduino language reference).
  // so if there is no obstacle to return an echo then unless a timeout is set
  // pulseIn() will return 0 after its timer times out and this routine 
  // will hang for 1 second.
  // The HC-SR04 has a range of about 10 feet, then since the speed of sound
  // is about 1 foot per milli-second it will take 20ms at maximum range.
  // so UStimeout is set to 20000 =20ms
const int UStimeout =20000;     //20ms
const byte uscm     =58;
const byte usinch   =147;
boolean f_cm        =true;      // US distance in cm
int UStime;       //pulsein usec
int Udist;       //conversion cm or inch 
byte objectRange ;    // distance to object detected by HC-SR04 sensor 
//===========================================================
