// Bambino
// TAB FILE > movement34.ino > movement49.ino

//     MOVEMENT - forward(), backward(), turnRight(), turnLeft(),    - by one pace
//                halt(), 
//                rollCentre(), rollLeft(), rollRight(),
//                paceCentre(), paceLeftForward(),  paceRightForward(), 
//                              paceLeftBackward(), paceRightBackward(), 
//                              turnLeftForward(),  turnRightForward(), 
//                              turnLeftBackward(), turnRightBackward(), 
//                rollmove(), pacemove()
//== NEW ====================================================
/*
*/
//== CHANGED ================================================
/*
void rollmove()    // do roll move   now calls doServos()
void pacemove()    // do pace move   now calls doServos()
*/
//===========================================================
// Bambino HK-15148
// +ve anti-clock
// +ve pace left forwards
// +ve roll right
//== MOVEMENT ===============================================
void forward()       // Walk one step forwards
{ f_forwards =1;
  if (paceat<paceC)
    { rollRight();  paceLeftForward();  rollCentre(); } 
   else
    { rollLeft();  paceRightForward();  rollCentre(); } 
  } 
//----------------------------
void backward()       // Walk one step backwards
{ f_forwards =0;
  if (paceat>paceC)
    { rollRight();  paceLeftBackward();  rollCentre(); } 
   else
    { rollLeft();  paceRightBackward();  rollCentre(); } 
  } 
//----------------------------
void turnRight()
{ // Turn right.
  // Bambino turns by sliding its feet in a 'tank' or 'skid' turn.
  // to turn right, the left foot must be forward. 
  // If it isn't then a step has to be made.
  f_turning =1;                // controls pace in turns
  if (paceat >= paceC)          // ie left foot forward       
    { turnRightForward(); }
   else
    { if (f_forwards) { forward(); } else { backward(); }
      turnRightForward();
      }
  f_TurnedRight =1;
  f_turning =0;
  }  
//----------------------------
void turnLeft()
{ // Turn left.
  // Bambino turns by sliding its feet in a 'tank' or 'skid' turn.
  // to turn right, the left foot must be forward. 
  // If it isn't then a step has to be made.
  f_turning =1;                // controls pace in turns
  if (paceat <= paceC)          // ie right foot forward      
    { turnLeftForward(); }
   else
    { if (f_forwards) { forward(); } else { backward(); }
      turnLeftForward();
      }
  f_TurnedRight =0;  
  f_turning =0;
  }
//----------------------------
void halt()                      // halt with both feet together
{ if (f_forwards)                // if going forwards
  { if (paceat > paceC)          // if left foot forward stand on left foot else right foot      
    { rollLeft(); } else { rollRight(); }     //
    }
   else                           // if going backwards
    { if (paceat > paceC)          // if left foot forward stand on right foot else left foot      
      { rollRight(); } else { rollLeft(); }
      } 
  paceCentre(); 
  rollCentre();
  }  
//----------------------------
void rollCentre()        { rollto =rollC;          rollmove(); }
void rollRight()         { rollto =rollC +rollby;  rollmove(); }
void rollLeft()          { rollto =rollC -rollby;  rollmove(); }
void paceCentre()        { paceto =paceC;          pacemove(); }
void paceRightForward()  { if (f_turning==1) {paceto =paceC -turnby; } else {paceto =paceC -paceby; } pacemove(); }
void paceLeftForward()   { if (f_turning==1) {paceto =paceC +turnby; } else {paceto =paceC +paceby; } pacemove(); }
void paceRightBackward() { paceLeftForward(); }
void paceLeftBackward()  { paceRightForward(); }
void turnRightForward()  { paceto =paceC -turnby;  pacemove(); }
void turnLeftForward()   { paceto =paceC +turnby;  pacemove(); }
void turnRightBackward() { turnLeftForward(); }
void turnLeftBackward()  { turnRightForward(); }
//----------------------------
void rollmove()    // do roll move  
{
  if (rollspeed==0) { rollspeed =1; }     // dont hang if 0
  if (rollto > rollat)
    { for (rollat =rollat; rollat <rollto; rollat +=rollspeed)  
      { doServos(); } 
    }  
   else     
    { for (rollat =rollat; rollat >rollto; rollat -=rollspeed)  
      { doServos();
      }
    }
  rollat =rollto; 
}
//----------------------------
void pacemove()    // do pace move
{ if (pacespeed==0) {pacespeed =1;}     // dont hang if 0 
  if (paceto > paceat)
    { for (paceat =paceat; paceat <paceto; paceat +=pacespeed)  
      { doServos(); }  
    }  
   else     
    { for (paceat =paceat; paceat >paceto; paceat -=pacespeed)  
      { doServos(); }
    }  
  paceat =paceto;
}
//===========================================================
