//== SECTIONS ===============================================
//== NEW 
//== CHANGED
//== INCLUDES
//     pins20.h     - pin usage
//     varsCons49.h - EEPROM addresses, general, Ultrasonic module HC-SR04
//     EEPROM.h       - the Arduino EEPROM library
//     avr/pgmspace.h - to allow the printHelp() text to be in ProgramSpace
//== VARIABLES and CONSTANTS 
//== HELP TEXT 
//     PROGMEM
//== SETUP
//== LOOP
//== USER ROUTINES
//   Experiment()      //until Quit
//   Xplore()          //Wander() until Quit
//   beAlive()         // the loop() from BA22_BeAlive
//== FUNCTIONS
//   waitNoIR()
//   NewCcmnd()
//   GetCcmnd()         //reads Serial or playing Act until Ccmnd != 0, prints Ccmnd
//   printCcmnd()
//   RecordCcmnd()  
//   makeCcmndDigit()  ensure 1-9
//   waitCcmndSecs()   //read delay time from Act and wait
//   printMind()
//   PrintReActs()
//   printReAct()
//   loadBehaviour()
//   get1char()
//   getnum()
//   getBehaviour()
//   printBehaviour()
//   PrintBehaviours()
//   DumpActs()        //Dump Acts, Print without names and length
//   loadAct()
//   copyAct()
//   Ccmnd <- PlayAct() 
//   PrintAllActs()
//   printAct()
//   Act <- getAct()  //called when recording, loading, printing and copying Acts 
//   setEEPROMindexes(char Act)      //  changes EEPROMindex, ActEnd
//   badkey()         // indicate invalid key
//   USreact()        // read Ultrasonic sensor and react to objectRange using avoidUObjects() behaviour rules
//   WhiskerReact()   // read Whisker sensors and avoid holes (if any) using avoidObstacles() behaviour rules
//   BeardReact()     // read Beard sensors and avoid obstacles (if any) using avoidHoles() behaviour rules
//   Quit()
//   redLEDdim() - BambinoMM only
//   redLEDon()
//   redLEDoff() 
//   bip()            // make a bip sound
//   whiskerLEDsDim() - not BambinoMM
//   whiskerLEDsOff() - not BambinoMM
//   beardLEDsOff()
//   IRin(byte pin)
//   IRtranslate()
//TAB FILES
//   acts51.ino
//     ACTS - WanderSteps(steps), Wander()
//            RightStep(steps), LeftStep(steps)
//            rock(repeats), shuffle(repeats)
//     SOUND -  whee(), whoa(), chatter(), beep(byte beeppin,int beepfreqHz,long beeptime)  
//   adjustServos45.ino
//     AdjustServos(), printEEPROMvalues(), printAdjustInstructions() 
//     PROGMEM adjust_instructions
//   behaviour46.ino
//     BEHAVIOUR MODIFIERS - speeddown(), speedup()
//                           disable_walking(), enable_walking(), toggle_f_walking()
//     BEHAVIOUR RULES - reactUObjects(), reactObstaclesLR(), reactHolesLR()
//                     - avoidUObjects(), avoidObstaclesLR(), avoidHolesLR()
//   help49.ino
//     HELP - printHelp() - Help text
//            printHelpActs, printHelpBehaviour, printHelpSystem
//   mind47.ino
//     MIND - getMind(), saveMind(),
//            initialiseEEPROM(), initBehaviour8(), initialiseEEPROMbehaviours1to7() 
//   movement49.ino
//     MOVEMENT - forward(), backward(), turnRight(), turnLeft(), 
//                halt(), 
//                rollCentre(), rollLeft(), rollRight(),
//                paceCentre(), paceLeftForward(),  paceRightForward(), 
//                              paceLeftBackward(), paceRightBackward(), 
//                              turnLeftForward(),  turnRightForward(), 
//                              turnLeftBackward(), turnRightBackward(), 
//                rollmove(), pacemove()
//   sense44.ino
//     SENSE - readUSdistance(), showUSdistance(), dist_HC_SR04()
//           - readWhiskers(), QueryObstacle(), showWhiskerLightLevels(), showObstacles() 
//           - readBeard(), QueryEdge(), showBeardLightLevels(), void showHoles()
//           - readLight()
//   servos49.ino
//     SERVOS - ServosInitC()
//              doServos()
//              ServoPulse(byte Spin, int Spulse)
//   skills41.ino
//     SKILLS - turnLight(), turnDark(), turnAtLight(), turnAtDark()
//     META MOVEMENT - turnAway(), turnMemory(), turnOther()  
//===========================================================
